from bs4 import BeautifulSoup
from lxml import etree
import requests
import re

class StofStat:
    def __init__(self,url,git_languages):
        self.url=url
        self.git_languages=git_languages
    
    def get_user_stats(self):

        sourceHtml = requests.get(self.url).text
        soup = BeautifulSoup(sourceHtml, 'lxml')
        user = soup.find('div', class_='fs-headline2')

        top_tags = []
        user_score = 0
        fav_language = "none"
        user_reputation = 0

        if user is None:
            print('404')
        else:
            # print(user.text)
            # check user reputation
            dom = etree.HTML(str(soup))
            user_rep_str = dom.xpath(
                '//*[@id="main-content"]/div[1]/div[1]/div/div[2]/div/div[1]/div')[0].text
            user_rep = re.sub('[^0-9]+', '', user_rep_str)
            user_reputation = int(user_rep)
            # print(user_reputation)

            if user_reputation > 15:
                self.url += '?tab=tags&sort=votes'
                # print(self.url)
                # get all tags
                source_user_stats = requests.get(self.url).text

                soup = BeautifulSoup(source_user_stats, 'lxml')
                tags_dom = etree.HTML(str(soup))
                tags_xpath = tags_dom.xpath(
                    '//*[@id="user-tab-tags"]/div[2]/table/tbody/tr[*]/td[*]/a')
                for tag in tags_xpath:
                    # print(tag.text)
                    top_tags.append(tag.text)

            else:
                pass
                # print('noob user')


        def find_fav_language(tag_list, language_list_git):
            if not tag_list and not language_list_git:
                # print('both null')
                return '404'
            elif not tag_list:
                # print('no tags found')
                return '404'
            elif not language_list_git:
                # print('no lang from git')
                return '404'
            else:
                for lang in language_list_git:
                    for tag in tag_list:
                        # print(lang, '::', tag)
                        if tag == lang:
                            # print('we have got a match', tag)
                            return tag
                    else:
                        continue
                return '404'


        fav_language=find_fav_language(top_tags,self.git_languages)


        def calculate_user_score():
            if user_reputation <= 10:
                return 15
            elif 10 < user_reputation <= 50:
                return 25
            elif 50 < user_reputation <= 150:
                return 35
            elif 150 < user_reputation <= 500:
                return 45
            elif 500 < user_reputation <= 1000:
                return 55
            elif 1000 < user_reputation <= 3000:
                return 65
            elif 3000 < user_reputation <= 8000:
                return 75
            elif 8000 < user_reputation <= 15000:
                return 85
            elif 15000 < user_reputation <= 55000:
                return 90
            elif 55000 < user_reputation <= 100000:
                return 95
            else:
                return 100


        # print('your score is:', calculate_user_score())
        stof_score = calculate_user_score()
        stof_stat = {"tags": top_tags, "stof_score": stof_score, "fav_language": fav_language}
        return stof_stat

