import Axios from 'axios'
import { portfolioPublicFetch } from '../util/fetcher'

export async function getGithubInfo(username) {
  // const url = `http://localhost:3001/api/stat/?username=${username}`
  const url = `/user/get-user/${username}`
  try {
    const response = await portfolioPublicFetch.get(url)
    const data = response.data
    console.log(data)
    return data['portfolio']
  } catch (err) {
    console.log('REST error: ', err)
    return err
  }
}
export async function checkUserValidty(username) {
  //const url = `http://localhost:3001/api/user-validity/?username=${username}`
  const url = `/user/check-git-account-availability/${username}`
  try {
    const response = await portfolioPublicFetch.get(url)
    //const response = await Axios.get(url);
    const data = response.data
    console.log('chk-01', data)
    return data
  } catch (err) {
    console.log('REST error: ', err)
    return err
  }
}
export async function checkPortfolioExists(username) {
  const url = `/user/check-availability/${username}`
  try {
    const response = await portfolioPublicFetch.get(url)
    const data = response.data
    console.log('portfolio exsitance-02:', data)
    return data
  } catch (err) {
    console.log('REST error: ', err)
    return err
  }
}
export async function getAllPortfolios() {
  const url = `/user/get-all-usernames`
  try {
    const response = await portfolioPublicFetch.get(url)
    const data = response.data
    console.log(data)
    return data
  } catch (err) {
    console.log('REST error: ', err)
    return err
  }
}
export async function createPortfolio(gitUsername, stofUsername, mediumUsername) {
  const url = `/user/create`
  try {
    const response = await portfolioPublicFetch.post(url, {
      git_username: gitUsername,
      stof_username: stofUsername,
      medium_username: mediumUsername,
    })

    const data = response.data
    console.log('portfolio creation-03', data)
    return data
  } catch (err) {
    console.log('REST error: ', err)
    return err
  }
}

export async function saveGithubInfo(userInfo) {
  console.log('here we go', userInfo)
  try {
    const response = await portfolioPublicFetch({
      method: 'POST',
      url: '/user/save-git-info',
      data: {
        name: userInfo.summary.stats.name,
        username: userInfo.summary.userBio.username,
        avatar_url: userInfo.summary.userBio.avatar_url,
        bio: userInfo.summary.userBio.bio,
        company: userInfo.summary.userBio.company,
        created_at: userInfo.summary.userBio.created_at,
        location: userInfo.summary.userBio.location,

        total_stars: userInfo.summary.stats.totalStars,
        total_prs: userInfo.summary.stats.totalPRs,
        total_commits: userInfo.summary.stats.totalCommits,
        total_issues: userInfo.summary.stats.totalIssues,
        contributed_to: userInfo.summary.stats.contributedTo,
        git_level: userInfo.summary.stats.overallClass.level,
        git_score: userInfo.summary.stats.overallClass.score,
        git_points: userInfo.summary.stats.overallClass.points,
        git_badge: userInfo.summary.stats.overallClass.badge
      }
    })
    console.log(response)
    return response
  } catch (error) {
    console.log('errrorIss', error)
    return error
  }
}

export function chooseClass(score) {
  let overallClass = 'Beginner'
  if (score > 90) {
    overallClass = 'Guru'
  }
  else if (score <= 90 && score > 80) {
    overallClass = 'Professional'
  }
  else if (score <= 80 && score > 70) {
    overallClass = 'Advanced'
  }
  else if (score <= 70 && score > 50) {
    overallClass = 'Intermediate'
  }
  else if (score <= 50 && score > 45) {
    overallClass = 'Intermediate'
  }
  else if (score <= 45 && score > 30) {
    overallClass = 'Beginner'
  }
  else if (score <= 30 && score > 10) {
    overallClass = 'Newbie'
  } else {
    overallClass = 'Newbie'
  }

  return overallClass
}
