import React from 'react'
import { Doughnut } from 'react-chartjs-2'

const DoughnutChart = (props) => {

  var favLangs=Object.values(props.languages).slice(0,6);
  console.log('langObjs',favLangs);
  const data = {
    /* labels: ['JavaScript', 'Java', 'PHP', 'Python', 'Dart', 'CSS'], */
    labels:favLangs.map(lang=>lang.name),
    datasets: [
      {
        label: 'Number of Lines',
        data: favLangs.map(lang=>lang.lines),
        backgroundColor: [
          'rgba(255, 99, 132, 0.7)',
          'rgba(54, 162, 235, 0.7)',
          'rgba(255, 206, 86, 0.7)',
          'rgba(75, 192, 192, 0.7)',
          'rgba(153, 102, 255, 0.7)',
          'rgba(255, 159, 64, 0.7)'
        ],
        borderColor: [
          'rgba(255, 99, 132, 1)',
          'rgba(54, 162, 235, 1)',
          'rgba(255, 206, 86, 1)',
          'rgba(75, 192, 192, 1)',
          'rgba(153, 102, 255, 1)',
          'rgba(255, 159, 64, 1)'
        ],
        borderWidth: 1.5
      }
    ]
  }
  const options = {
    plugins: {
      legend: { position: 'bottom' }
    }
  }
  return (
    <React.Fragment>
      <div className="header">
        <h1 className="title">Doughnut Chart</h1>
      </div>
      <Doughnut data={data} options={options} />
    </React.Fragment>
  )
}

export default DoughnutChart
