import React from 'react'
import Card from '@material-ui/core/Card'
import {
  Avatar,
  CardContent,
  CardHeader,
  Grid,
  List,
  ListItem,
  ListItemAvatar,
  ListItemText
} from '@material-ui/core'

import WorkIcon from '@material-ui/icons/Work'
import StarIcon from '@material-ui/icons/Star'
import BuildIcon from '@material-ui/icons/Build'
import LocationCityIcon from '@material-ui/icons/LocationCity'
import BugReportIcon from '@material-ui/icons/BugReport'
import TrendingUpIcon from '@material-ui/icons/TrendingUp'

export default function GitSummaryCard({ info }) {
  return (
    <Card>
      <CardHeader title="Git Stats"></CardHeader>
      <CardContent>
        <Grid container spacing={1}>
          <Grid item lg={6}>
            <List>
              <ListItem>
                <ListItemAvatar>
                  <Avatar>
                    <LocationCityIcon />
                  </Avatar>
                </ListItemAvatar>
                <ListItemText primary="Location" secondary={info.location} />
              </ListItem>
              <ListItem>
                <ListItemAvatar>
                  <Avatar>
                    <WorkIcon />
                  </Avatar>
                </ListItemAvatar>
                <ListItemText primary="Work" secondary={info.company} />
              </ListItem>
              <ListItem>
                <ListItemAvatar>
                  <Avatar>
                    <TrendingUpIcon />
                  </Avatar>
                </ListItemAvatar>
                <ListItemText primary="Total PRs" secondary={info.totalPRs} />
              </ListItem>
            </List>
          </Grid>

          <Grid item lg={6}>
            <List>
              <ListItem>
                <ListItemAvatar>
                  <Avatar>
                    <StarIcon />
                  </Avatar>
                </ListItemAvatar>
                <ListItemText
                  primary="Total Stars"
                  secondary={info.totalStars}
                />
              </ListItem>
              <ListItem>
                <ListItemAvatar>
                  <Avatar>
                    <BuildIcon />
                  </Avatar>
                </ListItemAvatar>
                <ListItemText
                  primary="Contributed To"
                  secondary={info.contributedTo}
                />
              </ListItem>
              <ListItem>
                <ListItemAvatar>
                  <Avatar>
                    <BugReportIcon />
                  </Avatar>
                </ListItemAvatar>
                <ListItemText
                  primary="Total Issues"
                  secondary={info.totalIssues}
                />
              </ListItem>
            </List>
          </Grid>
        </Grid>
      </CardContent>
    </Card>
  )
}
