import axios from 'axios'

const baseURL =
  process.env.NODE_ENV === 'development'
    ? 'http://localhost:8080/api'
    : process.env.NODE_ENV === 'production'
    ? `https://${process.env.PROD_SITE_NAME}/api`
    : `https://${process.env.SITE_NAME}/api` // staging

const portfolioURL =
  process.env.NODE_ENV === 'development'
    ? 'http://localhost:8000/api'
    : process.env.NODE_ENV === 'production'
    ? `https://${process.env.PORTFOLIO_PROD_SITE_NAME}/api`
    : `https://${process.env.PORTFOLIO_SITE_NAME}/api` // staging

const publicFetch = axios.create({
  baseURL
})
const portfolioPublicFetch = axios.create({
  baseURL:portfolioURL
})

export { publicFetch, portfolioPublicFetch, baseURL, portfolioURL }
