const mongoose = require("mongoose");
const uniqueValidator = require("mongoose-unique-validator");
const Schema = mongoose.Schema;

const userSchema = new Schema({
  username: { type: String, required: true, unique: true },
  name: { type: String },
  avatar_url: { type: String },
  bio: { type: String },
  company: { type: String },
  location: { type: String },
  created_at: { type: String },
  coding: {
    level: { type: Number },
    score: { type: Number },
    badge: { type: String },
    points: { type: Number },
  },
  git_langs: [{ name: { type: String }, lines: { type: Number } }],
  total_prs: { type: Number },
  total_commits: { type: Number },
  total_issues: { type: Number },
  total_stars: { type: Number },
  contributed_to: { type: Number },
  total_repos: { type: Number },
  total_followers: { type: Number },
  is_hireable: { type: Boolean },
  contribute_high_repos: [],
  contribute_mid_repos: [],
  contribute_low_repos: [],
  individual_high_repos: [],
  individual_mid_repos: [],
  individual_low_repos: [],
  profile_age: { type: Number },
  total_discussions: { type: Number },
  answered_discussions: { type: Number },
  stof_tags:[],
  stof_top_posts:[{name:{type:String}},{upvotes:{type:Number}},{date:{type:String}}],
  stof_rank:{score:{type:Number},class:{type:String}},
  stof_git_fav_language:{type:String},
  latest_update: { type: Date },
});
userSchema.plugin(uniqueValidator);
module.exports = User = mongoose.model("User", userSchema);
